//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jason Robinson."
#property link      "http://www.spreadtrade2win.com"
//MODIFIED BY KALENZO - contact@fxservice.eu
#property indicator_buffers 4
#property indicator_chart_window
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 4
#property indicator_width4 4




double TrendUp[], TrendDown[];
double BarUp[], BarDown[];
int changeOfTrend;


extern int    Nbr_Periods = 10;
extern double Multiplier  = 3.0;
extern int    Length      = 5;
extern int    Price       = 0;
extern double Phase       = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0, TrendUp);   SetIndexStyle(0, DRAW_LINE,    STYLE_SOLID, 2);  SetIndexLabel(0, "Trend Up");
   SetIndexBuffer(1, TrendDown); SetIndexStyle(1, DRAW_LINE,    STYLE_SOLID, 2);  SetIndexLabel(1, "Trend Down");
   SetIndexBuffer(2, BarUp);     SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(3, BarDown);   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1);
   
   
//----
   return(0);
  }

int deinit() {return(0);}



int start()
  {
   int limit, i, flag, flagh, trend[50000];
   double up[50000], dn[50000], medianPrice, atr;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);

   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;
   

   for (i = Bars; i >= 0; i--) {
      TrendUp[i] = EMPTY_VALUE;
      TrendDown[i] = EMPTY_VALUE;
      atr = iATR(NULL, 0, Nbr_Periods, i);
      double CloseVal  = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),     Length,Phase,i,   0);
      double HighVal   = iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),Length,Phase,i,  10);
      double LowVal    = iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i), Length,Phase,i,  20);
      medianPrice = (HighVal + CloseVal)/2;
   
      up[i]=medianPrice+(Multiplier*atr);
 
      dn[i]=medianPrice-(Multiplier*atr);
   
      trend[i]=1;
   
      
      if (CloseVal > up[i+1]) {
         trend[i]=1;
         if (trend[i+1] == -1) changeOfTrend = 1;
   
         
      }
      else if (CloseVal < dn[i+1]) {
         trend[i]=-1;
         if (trend[i+1] == 1) changeOfTrend = 1;
  
      }
      else if (trend[i+1]==1) {
         trend[i]=1;
         changeOfTrend = 0;       
      }
      else if (trend[i+1]==-1) {
         trend[i]=-1;
         changeOfTrend = 0;
      }

      if (trend[i]<0 && trend[i+1]>0) {
         flag=1;
   
      }
      else {
         flag=0;
 
      }
      
      if (trend[i]>0 && trend[i+1]<0) {
         flagh=1;
  
      }
      else {
         flagh=0;
  
      }
      
      if (trend[i]>0 && dn[i]<dn[i+1])
         dn[i]=dn[i+1];
      
      if (trend[i]<0 && up[i]>up[i+1])
         up[i]=up[i+1];
      
      if (flag==1)
         up[i]=medianPrice+(Multiplier*atr);
         
      if (flagh==1)
         dn[i]=medianPrice-(Multiplier*atr);
         
    
      if (trend[i]==1) {
         TrendUp[i]= dn[i];
         BarUp[i] = High[i];
         BarDown[i] = Low[i];
         
         if (changeOfTrend == 1) {
            TrendUp[i+1] = TrendDown[i+1];
            changeOfTrend = 0;
         }
      }
      else if (trend[i]==-1) {
         TrendDown[i]=up[i];
         BarUp[i] = Low[i];
         BarDown[i] = High[i];
         if (changeOfTrend == 1) {
            TrendDown[i+1] = TrendUp[i+1];
            changeOfTrend = 0;
         }
      }
   }
   WindowRedraw();
      
//----
   return(0);
  }
//+------------------------------------------------------------------+


   
double wrk[][30];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}